#pragma once

#include "CoreMinimal.h"
#include "EventDrivenModifierCondition.h"
#include "Templates/SubclassOf.h"
#include "ImposedStatusEffectCondition.generated.h"

class UStatusEffect;

UCLASS(Blueprintable, Abstract, EditInlineNew, meta=(BlueprintSpawnableComponent))
class DBDCOMPETENCE_API UImposedStatusEffectCondition : public UEventDrivenModifierCondition
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	TSubclassOf<UStatusEffect> _classTypeToMatch;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, ReplicatedUsing=OnRep_IsApplicable, Transient, meta=(AllowPrivateAccess=true))
	bool _isApplicable;

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_IsApplicable();

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UImposedStatusEffectCondition();
};

FORCEINLINE uint32 GetTypeHash(const UImposedStatusEffectCondition) { return 0; }
